clear all

program define RegOut //多行输出
	local   m  1
	local   aa
	foreach YV of global YY {
		foreach XV of global XX {
			qui reg `YV' `XV' $CC
			est store a`m'
			local aa = "`aa' " + "a`m'"
			local m = `m' + 1
		}

	}
	
	esttab `aa' , append compress nogaps varwidth(18) modelwidth(12) ///
		star(* 0.10 ** 0.05 *** 0.01) ar2(%9.4f) t(%6.4f) b(%6.4f) ///
		indicate("Time fixed effect=*.季度" "Bank fixed effect=*.id") ///
		order($XX) ///
		title("$TT")  mtitles()  
	reg2docx `aa' using 论文回归模型.docx, append ///
		star(* 0.10 ** 0.05 *** 0.01) scalars(N r2_a(%9.4f)) se(%6.4f) b(%6.4f) ///
		indicate("Time fixed effect=*.季度" "Bank fixed effect=*.id") ///
		order($XX) ///
		title("$TT")  mtitles()  font("Times New Roman", 9) 
end


program define Sgmediation
	local   m  1
	local   aa
	local   bb
	foreach MV of global MM {
		foreach XV of global XX {
			qui reg  `MV'  `XV'   $CC  ,  r
			est store a`m'
			local aa = "`aa' " + "a`m'"
			local m = `m' + 1
			
			foreach YV of global YY {
				qui sgmediation `YV' , mv(`MV') iv(`XV') cv($CC) 
				est store a`m'

				
				if `m' > 5 { //输出后面的，注意此处要修改，为总体的二分之一
					set more off                  
					putdocx begin, pagesize(A4) font(Times New Roman,9,black)  margin(all, 0.1) //打开 Word 文档
					putdocx paragraph, halign(center) spacing (line, 0.15) //两端对齐
					putdocx text ("Sobel Mediation Test (Z):                    `r(sobel_Z)' "), ///
						font(Times New Roman,9,black)  linebreak
					putdocx text ("Proportion of total effect that is mediated: `r(ind2tot)' "), ///
						font(Times New Roman,9,black)  linebreak
					putdocx save "论文回归模型.docx", append	 
				}

				
				local aa = "`aa' " + "a`m'"
				local m = `m' + 1
			}
		}
		local bb `MV'
	} 
	
/*	esttab `aa' , append compress nogaps varwidth(18) modelwidth() ///
		star(* 0.10 ** 0.05 *** 0.01) ar2(%9.4f) se(%6.4f) b(%6.4f)  ///
		order($XX $xlist `bb')  ///
		indicate("Time fixed effect=*quarter*" "Bank fixed effect=*indi*") ///
		title("$TT")  mtitles()   */
	reg2docx a1 a7 a8 a9 a10 using 论文回归模型.docx, append ///
		star(* 0.10 ** 0.05 *** 0.01) scalars(N r2_a(%9.4f) ) se(%6.4f) b(%6.4f) ///
		order($XX `bb') ///
		indicate("Time fixed effect=*quarter*" "Bank fixed effect=*indi*") ///
		title("$TT")  mtitles()   font("Times New Roman", 9)  
	
end


